<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: Widget.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_widget_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Widget.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_widget_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// %flair:license{</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// This file is part of the Flair framework distributed under the</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// CECILL-C License, Version 1.0.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// %flair:license}</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"></span><span class="preprocessor">#ifndef WIDGET_H</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define WIDGET_H</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_object_8h.html">Object.h</a>&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//#include &lt;io_data.h&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;libxml/xpath.h&gt;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">class </span>Widget_impl;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">class </span>FrameworkManager_impl;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">namespace </span>gui {</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="classflair_1_1gui_1_1_widget.html">   38</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1gui_1_1_widget.html">Widget</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1core_1_1_object.html">core::Object</a> {</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;  <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1_framework_manager.html">core::FrameworkManager</a>;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;  <span class="keyword">friend</span> class ::Widget_impl;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;  <span class="keyword">friend</span> class ::FrameworkManager_impl;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;  <a class="code" href="classflair_1_1gui_1_1_widget.html#a7b867cc6c603cbc5e5a2f39f083a9494">Widget</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1gui_1_1_widget.html">Widget</a> *parent, std::string name, std::string type);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;  <span class="keyword">virtual</span> <a class="code" href="classflair_1_1gui_1_1_widget.html#a81110928e09e909dc1cc90971de4e8a9">~Widget</a>();</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1gui_1_1_widget.html#a814a933622114ad9c8f5d49014262d89">setEnabled</a>(<span class="keywordtype">bool</span> status);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;  <span class="keywordtype">bool</span> <a class="code" href="classflair_1_1gui_1_1_widget.html#a299877c38b297ada04542e4dfc5a2f4f">isEnabled</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keywordtype">void</span> <a class="code" href="classflair_1_1gui_1_1_widget.html#a0e81847db5a84b2e7e26545c9b1b704f">SetPersistentXmlProp</a>(std::string prop, T value);</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keywordtype">bool</span> <a class="code" href="classflair_1_1gui_1_1_widget.html#a6404c7f474be994ec4e72a97e45dfffa">GetPersistentXmlProp</a>(std::string prop, T &amp;value);</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1gui_1_1_widget.html#abe5ab96255919238138527c92fbeb6d8">SetVolatileXmlProp</a>(std::string prop, T value, xmlNodePtr node = NULL);</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1gui_1_1_widget.html#ac80f72906580f269b5881c1ef0b35afb">SendXml</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div>
<div class="line"><a name="l00143"></a><span class="lineno"><a class="line" href="classflair_1_1gui_1_1_widget.html#a92d4e0613146c9b348b388f3f75cca9e">  143</a></span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classflair_1_1gui_1_1_widget.html#a92d4e0613146c9b348b388f3f75cca9e">XmlEvent</a>(<span class="keywordtype">void</span>){};</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1gui_1_1_widget.html#a9ba37bd7fad0f4a97175d922b93b5434">UnsetPersistentXmlProp</a>(std::string prop);</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;  <span class="keyword">class </span>Widget_impl *pimpl_;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;};</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;} <span class="comment">// end namespace gui</span></div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;} <span class="comment">// end namespace flair</span></div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="preprocessor">#endif // WIDGET_H</span></div>
<div class="ttc" id="classflair_1_1core_1_1_object_html"><div class="ttname"><a href="classflair_1_1core_1_1_object.html">flair::core::Object</a></div><div class="ttdoc">Base class for all Framework&#39;s classes. </div><div class="ttdef"><b>Definition:</b> Object.h:83</div></div>
<div class="ttc" id="namespaceflair_html"><div class="ttname"><a href="namespaceflair.html">flair</a></div><div class="ttdoc">namespace of the flair Framework </div><div class="ttdef"><b>Definition:</b> Ahrs.h:19</div></div>
<div class="ttc" id="classflair_1_1gui_1_1_widget_html_a92d4e0613146c9b348b388f3f75cca9e"><div class="ttname"><a href="classflair_1_1gui_1_1_widget.html#a92d4e0613146c9b348b388f3f75cca9e">flair::gui::Widget::XmlEvent</a></div><div class="ttdeci">virtual void XmlEvent(void)</div><div class="ttdoc">Xml event. </div><div class="ttdef"><b>Definition:</b> Widget.h:143</div></div>
<div class="ttc" id="classflair_1_1gui_1_1_widget_html_a6404c7f474be994ec4e72a97e45dfffa"><div class="ttname"><a href="classflair_1_1gui_1_1_widget.html#a6404c7f474be994ec4e72a97e45dfffa">flair::gui::Widget::GetPersistentXmlProp</a></div><div class="ttdeci">bool GetPersistentXmlProp(std::string prop, T &amp;value)</div><div class="ttdoc">Get a persistent xml property. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_widget_html_abe5ab96255919238138527c92fbeb6d8"><div class="ttname"><a href="classflair_1_1gui_1_1_widget.html#abe5ab96255919238138527c92fbeb6d8">flair::gui::Widget::SetVolatileXmlProp</a></div><div class="ttdeci">void SetVolatileXmlProp(std::string prop, T value, xmlNodePtr node=NULL)</div><div class="ttdoc">Set a volatile xml property. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_widget_html_a0e81847db5a84b2e7e26545c9b1b704f"><div class="ttname"><a href="classflair_1_1gui_1_1_widget.html#a0e81847db5a84b2e7e26545c9b1b704f">flair::gui::Widget::SetPersistentXmlProp</a></div><div class="ttdeci">void SetPersistentXmlProp(std::string prop, T value)</div><div class="ttdoc">Set a persistent xml property. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_widget_html_a9ba37bd7fad0f4a97175d922b93b5434"><div class="ttname"><a href="classflair_1_1gui_1_1_widget.html#a9ba37bd7fad0f4a97175d922b93b5434">flair::gui::Widget::UnsetPersistentXmlProp</a></div><div class="ttdeci">void UnsetPersistentXmlProp(std::string prop)</div><div class="ttdoc">Unset a persistent xml property. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_widget_html_a81110928e09e909dc1cc90971de4e8a9"><div class="ttname"><a href="classflair_1_1gui_1_1_widget.html#a81110928e09e909dc1cc90971de4e8a9">flair::gui::Widget::~Widget</a></div><div class="ttdeci">virtual ~Widget()</div><div class="ttdoc">Destructor. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_widget_html_a814a933622114ad9c8f5d49014262d89"><div class="ttname"><a href="classflair_1_1gui_1_1_widget.html#a814a933622114ad9c8f5d49014262d89">flair::gui::Widget::setEnabled</a></div><div class="ttdeci">void setEnabled(bool status)</div><div class="ttdoc">Set enabled. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_widget_html_a299877c38b297ada04542e4dfc5a2f4f"><div class="ttname"><a href="classflair_1_1gui_1_1_widget.html#a299877c38b297ada04542e4dfc5a2f4f">flair::gui::Widget::isEnabled</a></div><div class="ttdeci">bool isEnabled(void) const </div><div class="ttdoc">Is enabled? </div></div>
<div class="ttc" id="classflair_1_1core_1_1_framework_manager_html"><div class="ttname"><a href="classflair_1_1core_1_1_framework_manager.html">flair::core::FrameworkManager</a></div><div class="ttdoc">Main class of the Framework library. </div><div class="ttdef"><b>Definition:</b> FrameworkManager.h:45</div></div>
<div class="ttc" id="classflair_1_1gui_1_1_widget_html_a7b867cc6c603cbc5e5a2f39f083a9494"><div class="ttname"><a href="classflair_1_1gui_1_1_widget.html#a7b867cc6c603cbc5e5a2f39f083a9494">flair::gui::Widget::Widget</a></div><div class="ttdeci">Widget(const Widget *parent, std::string name, std::string type)</div><div class="ttdoc">Constructor. </div></div>
<div class="ttc" id="_object_8h_html"><div class="ttname"><a href="_object_8h.html">Object.h</a></div><div class="ttdoc">Base class for all Framework&#39;s classes. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_widget_html"><div class="ttname"><a href="classflair_1_1gui_1_1_widget.html">flair::gui::Widget</a></div><div class="ttdoc">Abstract class for all Framework&#39;s widget classes. </div><div class="ttdef"><b>Definition:</b> Widget.h:38</div></div>
<div class="ttc" id="classflair_1_1gui_1_1_widget_html_ac80f72906580f269b5881c1ef0b35afb"><div class="ttname"><a href="classflair_1_1gui_1_1_widget.html#ac80f72906580f269b5881c1ef0b35afb">flair::gui::Widget::SendXml</a></div><div class="ttdeci">void SendXml(void)</div><div class="ttdoc">Send xml. </div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_33c2ee9b1665499374b4225c427cf176.html">igep</a></li><li class="navelem"><a class="el" href="dir_f1fe274389177bd7e17de7949c4ffada.html">flair-src</a></li><li class="navelem"><a class="el" href="dir_3ef62148cf94871b4b6ee5d6e3a989c1.html">lib</a></li><li class="navelem"><a class="el" href="dir_97265977dbbd48c696782ccac102bad5.html">FlairCore</a></li><li class="navelem"><a class="el" href="dir_6c198461db290ac9abcdd44184573216.html">src</a></li><li class="navelem"><a class="el" href="_widget_8h.html">Widget.h</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
